--
-- Minimum Database configuration
--

update db cfg using APPLHEAPSZ 2048 @


--
-- DDL to register stored procedures and functions
--

drop procedure sendexcel (varchar(255), varchar(255), varchar(255), varchar(255), varchar(255), varchar(255), varchar(32000), varchar(255))@
drop procedure sendexcel (varchar(255), varchar(255), varchar(255), varchar(255), varchar(255), varchar(255), varchar(32000), varchar(32000), varchar(255))@
drop function sendmail(varchar(), varchar(), varchar(), varchar(), varchar(), varchar(), clob(), varchar(), clob(), varchar(), clob(), varchar()) @
drop function sql2excel (varchar()) @
drop function sql2excel (varchar(), varchar()) @
drop procedure sql2excel (varchar(), clob()) @
drop procedure sql2excel (varchar(), varchar(), clob()) @


-- 
-- Stored procedure to generate SQL resultset in Microsoft Excel XML format
-- (works on MPP, 64 bit)
-- 

-- w/o pivot table specification

create procedure sql2excel (in stmt varchar(32000), out excel clob(32M))
   external name 'sql2excel!sql2excelSh'
   reads sql data fenced
   language c parameter style sql dbinfo @ 

-- w/ pivot table specification

create procedure sql2excel (in stmt varchar(32000), in ptsheet varchar(32000), out excel clob(32M))
   external name 'sql2excel!sql2excel'
   reads sql data fenced
   language c parameter style sql dbinfo @ 


--
-- Scalar function to generate SQL resultset in Microsoft Excel XML format
-- (only works in serial mode)
--

-- w/o pivot table specification

create function sql2excel (stmt varchar (32000)) 
      returns CLOB(32M)
    external name 'sql2excel!sql2excelFctSh'
    language c parameter style db2sql
    fenced called on null input
    scratchpad final call
    deterministic reads sql data no external action allow parallel @

-- w/ pivot table specification

create function sql2excel (stmt varchar (32000), ptsheet varchar(32000)) 
      returns CLOB(32M)
     external name 'sql2excel!sql2excelFct'
     language c parameter style db2sql
     fenced called on null input
     scratchpad final call
     deterministic reads sql data no external action allow parallel @


--
-- UDF to send email attachment
--

create function sendmail(gateway VARCHAR(255), sender VARCHAR(255), senderPersonal VARCHAR(255), recipient VARCHAR(255), 
                         subject VARCHAR(255), body VARCHAR(255),
                         att1 CLOB(32M), attName1 VARCHAR(255), 
                         att2 CLOB(4), attName2 VARCHAR(4), att3 CLOB(4), attName3 VARCHAR(4))
returns integer
   external name 'com.ibm.almaden.SendMailUDF!send'
   language java  parameter style db2general 
   not fenced deterministic
   null call no sql external action
   no scratchpad allow parallel no dbinfo @


--
--  Stored procedure to send mail
--

-- w/ pivot table specification

CREATE PROCEDURE sendexcel (in gateway VARCHAR(255), in sender VARCHAR(255), in senderPersonal VARCHAR(255), in recipient VARCHAR(255), 
                            in subject VARCHAR(255), 
                            in body VARCHAR(255),
                            in stmt varchar(32000), in attName1 VARCHAR(255))
   external name 'sql2excel!sendexcelSh'
   language c parameter style sql
   reads sql data fenced @

-- w/o pivot table specification

CREATE PROCEDURE sendexcel (in gateway VARCHAR(255), in sender VARCHAR(255), in senderPersonal VARCHAR(255), in recipient VARCHAR(255), 
                            in subject VARCHAR(255), 
                            in body VARCHAR(255),
                            in stmt varchar(32000), in ptsheet varchar(32000), in attName1 VARCHAR(255))
   external name 'sql2excel!sendexcel'
   language c parameter style sql
   reads sql data fenced @




